
Foreman - Bug #16576

Structured facts importer is extremely slow

09/15/2016 08:09 PM - Brandon Weeks

Status: Closed   

Priority: Normal   

Assignee: Dominic Cleal   

Category: Facts   

Target version: 1.13.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases: 1.13.0

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/3852

  

Description

After upgrading to 1.13.0-RC1, our Foreman server consumed all available resources and became effectively unusable with

response times of 25k to 175k ms. This seems directly related to the changes made in #4528, as Api::V2::HostsController#facts is

where the application spends 99% of its time after upgrade according to NewRelic.

https://gist.github.com/brandonweeks/94b93e343dca4395c17815e24aaeb879

Related issues:

Related to Foreman - Feature #4528: Support Facter 2 structured facts Closed 03/03/2014

Related to Foreman - Feature #12163: Add ability to expire facts based on fac... Closed 10/14/2015

Related to Foreman - Bug #9016: Fact import code consumes lot of memory Closed 01/18/2015

Associated revisions

Revision e5381d3f - 09/19/2016 10:26 AM - Dominic Cleal

fixes #16576 - only load FactName IDs, not models during import

Restores behaviour from before c696f74, which only keeps FactName IDs to

avoid loading the entire model. For structured facts, the compose values

are also preloaded, so the model is only loaded and updated if the value

of compose changes from the preloaded value.

Revision c2eca541 - 09/26/2016 07:38 AM - Dominic Cleal

fixes #16576 - only load FactName IDs, not models during import

Restores behaviour from before c696f74, which only keeps FactName IDs to

avoid loading the entire model. For structured facts, the compose values

are also preloaded, so the model is only loaded and updated if the value

of compose changes from the preloaded value.

(cherry picked from commit e5381d3ff9001d9fe3ce8d0f90afeec591571e97)

History

#1 - 09/15/2016 09:07 PM - Brandon Weeks

This was mostly caused by a massive numbers of orphaned rows in the fact_names table. Here is a SQL query that removes any fact_names without

corresponding values.

DELETE

FROM fact_names

WHERE fact_names.id NOT IN (SELECT DISTINCT fact_name_id FROM fact_values);

#2 - 09/16/2016 02:56 AM - Dominic Cleal

- translation missing: en.field_release set to 160

#3 - 09/16/2016 03:31 AM - Dominic Cleal

- Status changed from New to Assigned
- Assignee set to Dominic Cleal

#4 - 09/16/2016 03:32 AM - Dominic Cleal

- Related to Feature #4528: Support Facter 2 structured facts added

#5 - 09/16/2016 03:41 AM - Dominic Cleal

- Related to Feature #12163: Add ability to expire facts based on fact name. added

#6 - 09/16/2016 03:58 AM - Lukas Zapletal

- Related to Bug #9016: Fact import code consumes lot of memory added

#7 - 09/16/2016 03:59 AM - Lukas Zapletal

This patch #9016 fixes it, we are just finishing the review process. Could you try it and share some numbers?

https://github.com/theforeman/foreman/pull/3667

#8 - 09/16/2016 04:17 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/3852 added

#9 - 09/19/2016 11:06 AM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset e5381d3ff9001d9fe3ce8d0f90afeec591571e97.
